**
*procedure errrtn
**
parameter errline, _prg

*/ ERRRTN - Traps multi-user contention errors (108, 109, and 110), and

ERRCODE=ERROR()


do case
  case ERRCODE=108 .OR. ERRCODE=109 .OR. ERRCODE=110 .or. errcode=1705 .or. errcode=1106
     softerr=softerr+1

     IF TYPE('_prg') = 'C'
        =ADDLOG ("*** Error at Module -> "+_prg ,t_prog)
     ENDIF

     MESSAGE = "SOFT SYSTEM ERROR # "+STR(ERRCODE)+" - "+MESSAGE()
     =ADDLOG ("*** "+str(errcode)+" - "+message() ,t_prog)

     SRCCODE = "SOURCE CODE LINE: "+MESSAGE(1)

     =ADDLOG (srccode+' ' ,t_prog)
     =ADDLOG ('Locked DBF='+dbf()+' ' ,t_prog)

     IF TYPE('ERRLINE') = 'N'
        message = 'ERROR AT LINE NO -> '+STR(ERRLINE,5)
        =ADDLOG ("*** Error at line no -> "+str(errline,5) ,t_prog)
     ENDIF

     do case
        case softerr = 1
        case softerr > 100
          logging = .t.
          list memory to file (dbfdir+'error.txt')
 *         run /n1 notepad.exe error.txt
*          do foxdump
          quit
        otherwise
     endcase


     IF TYPE('ERRLINE') = 'N'
        message2 = 'ERROR AT LINE NO -> '+STR(ERRLINE,5)
     ENDIF

     wait 'Record Locked by Another User - Reprocessing - Try:'+str(softerr)+chr(13)+srccode window timeout 5
     wait clear
     retry
 case errcode=130
     wait 'Push Enter or Tab to update field before Calc or Totaling' window timeout 10
     quit

 otherwise

     logging = .t.
     t_prog = 'ERROR'

     IF TYPE('_prg') = 'C'
        =ADDLOG ("*** Error at Module -> "+_prg ,t_prog)
     ENDIF

     for ecnt = 0 to 32
        if len(program(ecnt)) <> 0
           =ADDLOG ("*** calls "+program(ecnt)+' ' ,t_prog)
        else
          exit
        endif
     next ecnt

     =ADDLOG ("*** "+str(errcode)+" - "+message() ,t_prog)

     MESSAGE = "SYSTEM ERROR # "+STR(ERRCODE)+" - "+MESSAGE()
     SRCCODE = "SOURCE CODE LINE: "+MESSAGE(1)
     =ADDLOG ("*** "+message(1) ,t_prog)

     IF TYPE('ERRLINE') = 'N'
        message = 'ERROR AT LINE NO -> '+STR(ERRLINE,5)
        =ADDLOG ("*** Error at line no -> "+str(errline,5) ,t_prog)
     ENDIF

     MESSAGE = "SYSTEM ERROR # "+STR(ERRCODE)+" - "+MESSAGE()
     ON ERROR
  *   list memory to print
  *   list memory to (dbfdir+'error.txt')
        list memory to c:\error.txt
     wait "an error occured - check error.txt" window

*     DO foxDUMP
     quit
endcase

return


**
FUNCTION ADDLOG
**
parameters outmsg, outproc, nomess
private wrkarea
return .t.
